-- Methods for:
--   running a dos .bat file without a window showing
--   pause script execution until .bat script has completed

global g_pdb_maxIters = 100 -- 20 secs with 0.2 secs between each check

global g_dlg_pdbStatus
global g_tmpperido = (getDir #scripts) + "\\prettydostemp" 

rollout g_dlg_pdbStatus "Progress" width:200 height:60
(
	progressBar pb1 "ProgressBar" pos:[8,30] width:180 height:20
	label lbl1 "Please Wait..." pos:[34,15] width:80 height:16
)


fn pdb_PROC_End =
(
	DestroyDialog g_dlg_pdbStatus
)

fn pdb_PROC_Start =
(
	-- prevent multiple copies of this dialog
	pdb_PROC_End()
	
	createDialog g_dlg_pdbStatus
)

fn pdb_PROC_Update =
(
	local tmpVal = g_dlg_pdbStatus.pb1.value + 1
	if tmpVal > 100 then tmpVal = 0
	
	g_dlg_pdbStatus.pb1.value = tmpVal
)



-----------------------------------------
-- this is the wait function
fn pdb_status fname iter_cnt waitTime =
(
	-- check if this fname exists
	-- format " %, " iter_cnt
	
	if (getFiles fname).count > 0 then -- .bat file complete
	(

		DeleteFile ( g_tmpperido + ".bat" )
		pdb_PROC_End()
	)
	else
	(
		-- prevent never ending loop in-case something goes wrong
		if iter_cnt > g_pdb_maxIters then
		(
			print "Batchfile timed out!"
			--DeleteFile ( g_tmpperido + ".tmp" )
			pdb_PROC_End()
		)
		else
		(
			iter_cnt += 1
			pdb_PROC_Update()
			sleep waitTime
			pdb_status fname iter_cnt waitTime
		)
	)
	
	
)


fn prettyDosBatch cmd =
(
	-- The batch file to execute
	local f = fopen (g_tmpperido + ".bat") "w"
	--local temp = fopen (g_tmpperido + ".tmp") "w"
	--fclose temp
	if f != undefined then
	(
		bf_WriteString2 f "\""
		bf_WriteString2 f cmd
		--writeString f "\necho done > \""
		--writeString f g_tmpperido
		--writeString f ".tmp\"\n"
		fclose f
		if (getFiles ( g_tmpperido + ".bat" ) ).count == 1 then
		(
			-- todo use plugin ver of this (no window)
			cmd = g_tmpperido + ".bat"
			HiddenDOSCommand cmd
			
			pdb_PROC_Start()
			
			pdb_status ( g_tmpperido + ".bat" ) 0 0.1
		)
		DeleteFile ( g_tmpperido + ".bat" )
		
	)
)



/*
(
	clearListener()
	prettyDosBatch "call D:\\3dsmax5\\scripts\\test1.bat"
)
*/