-- Sh0v0r global function -------------------------------------------------------------------
fn findTerrainNode =
(	for i = 1 to rootnode.children.count do
		if ( rootnode.children[i].name == "terrain" ) then return rootnode.children[i]
	return undefined
)
---------------------------------------------------------------------------------------------
-----------------------------------------------
-----------------------------------------------
-----------------------------------------------
fn thisfileDoesExist thisfile =
(
	f = fopen thisfile "rb"
	if f != undefined do
	( fclose f
		return true
	)
	return false
)
fn eventrue inputNum =
(	if ((inputNum as integer) / 2 * 2) == inputNum do return true
	return false
)

-----------------------------------
fn makeintoDigits thisValue=
(	if thisValue < 10 do
		return ("0" + (thisValue as string))
	return (thisValue as string)
)
-------------------------------------
fn parseTxName prefix y x suffix=
	return prefix+(makeintoDigits (y-1))+"x"+(makeintoDigits (x-1))+suffix
-------------------------------------
mapped fn reAlingnTerrain thisOb =
(
	vertsInSeg = sqrt(thisOb.numverts) as integer
	segOffset = thisOb.min
	segSiz = (thisOb.max.x - thisOb.min.x ) / (vertsInSeg - 1)
	--print (segSiz as string)
	for y=1 to vertsInSeg do
	(
		yInxOffset = (y-1) * vertsInSeg 
		yPosOffset = (y-1) * segSiz 
		for x=1 to VertsInSeg do
		(
			tmpInx = (yInxOffset+x)
			tmpVert = (getvert thisOb tmpInx).z
			setvert thisOb (yInxOffset+x) [ (x-1)*segSiz,yPosOffset ,tmpVert]
			
		)
	)
)
-----------------------------------------------

-----------------------------------------------
-----------------------------------------------

fn generateBfheightmapSeg terrainworldSize terrainScale dRes hmValu=
(
	zMul = terrainScale  / 256.0
	mulCord = terrainworldSize / dRes
	
	vertlist = #()
	facelist = #()
	draU = (dRes+1)
	
	
	
	--print ("mulCord: "+(mulCord as string))
	--print ("zMul: "+(zMul as string))
	--print ("dRes+1: "+(draU as string))
	--print ("actualVertsUsed: "+((draU*draU) as string))
	
	--- create the vertices
	tmpY = 0
	tmpZ = 0
	tmp_a = 0
	(
		for y=1 to draU do
		(
			tmpY = (y-1)*mulCord
			tmp_a = (y-1)*draU
			for x=1 to draU do
			(
				tmpZ = hmValu[(tmp_a + x)]
				vertlist[tmp_a + x] = [(x-1)*mulCord,tmpY,tmpZ*zMul]
			)	
		)
	
	)
	
	
	---- Tesselate faces ---
	faceInx = 1
	-- for i=1 to dRes*dRes*2 do facelist[i] = [1,2,3]
	-- odds  have / 
	-- even verts have \ 
	(
		tOffa = 0 -- tmpOffsetA
		for y=1 to dRes do
		(	tmp_a = y*draU
			if (eventrue y) == false do
			for x=1 to dRes/2 do
			(	tOffa = (y-1)*draU + (x * 2 - 1)
	
				facelist[faceInx] =   [tOffa,   tOffa+1, (draU + tOffa + 1)]
				facelist[faceInx+1] = [tOffa+1, tOffa+2, (draU + tOffa + 1)]
				faceInx += 2
				facelist[faceInx] =   [tOffa,  tOffa+draU+1, tOffa+draU]
				facelist[faceInx+1] = [tOffa+2, tOffa+draU+2, tOffa+draU+1]
				faceInx += 2
				facelist[faceInx] =   [tOffa+draU,  tOffa+draU+1, tOffa+draU*2]
				facelist[faceInx+1] = [tOffa+draU+1,  tOffa+draU*2+1, tOffa+draU*2]
				faceInx += 2
				facelist[faceInx] =   [tOffa+draU+1,  tOffa+2+draU*2, tOffa+1+draU*2]
				facelist[faceInx+1] = [tOffa+draU+1,  tOffa+2+draU, tOffa+2+draU*2]
				faceInx += 2
			)
		)
	)
	----
	
	t = mesh vertices:vertlist faces:facelist
		gc()
	return t
)


----------------------------------------------------------
-------------Function: read heightmap 65x65 segment ------
----------------------------------------------------------
fn readbfHMseg thisFileName Xseg Yseg isFinalSegX isFinalSegY=
(
	f=fopen thisFileName "rb"
--print ("HeighmapFile: "+(thisFileName as string))
	fseek f 0 #seek_end
	theFileSize = (ftell f)
--print ("theFileSize: "+(theFileSize as string))
	fseek f 0 #seek_set
	theFileResolution = (sqrt(theFileSize/2) as integer)
--print ("File Res: "+(theFileResolution as string))

	StartSeek = (Yseg-1) * theFileResolution * 128  + (Xseg-1) * 128

--print ("StartSeek: "+(StartSeek as string))

	hmValu = #()
	if isFinalSegX == false and isFinalSegY == false then
	(-- print "regSeg"
		for y=1 to 65 do
		(
			fseek f (StartSeek+ (y-1) * theFileResolution  * 2 ) #seek_set
			tmpYv = (y-1)*65
			for x=1 to 65 do
			(	hmValu[ tmpYv + x] = readshort f #unsigned
			)
		)
	)
	else
	(-- print "endseg"
		y_zer = 65
		x_zer = 65
		if isFinalSegY do y_zer = 64
		if isFinalSegX do x_zer = 64
		for y=1 to y_zer do
		(
			fseek f (StartSeek + (y-1) * theFileResolution  * 2 ) #seek_set
			tmpYv = (y-1)*65
			for x=1 to x_zer do
			(	hmValu[ tmpYv + x] = readshort f #unsigned
			)
			if isFinalSegX do
			(	fseek f ( (Yseg-1) * theFileResolution * 128 +  (y-1) * theFileResolution  * 2 ) #seek_set
				hmValu[ tmpYv + 65] = readshort f #unsigned
			)
		)
		if isFinalSegY do
		(
			fseek f ((Xseg-1) * 128) #seek_set
			
			for x=1 to 65 do -- 4160 = 64*65
			(	hmValu[4160 + x] = readshort f #unsigned
			)	
		)	
	)		
	fclose f

		

	return hmValu
)




---------------------------------------------------------------------------------------------
fn importBfterrain hmFileName usewater IdoTextures=
(taskStartTime = timestamp()
	if hmFileName != undefined do
	(
--//Terrain.con
		print "--------------------"
		terrainConFile = ((getFilenamePath hmFileName)+"Init\\Terrain.con")
		print ("terrainConFile: "+(terrainConFile as string))
			terrainScale = gl_defaultTerrainScale
			terrainworldSize = gl_defaultWorldSize
			waterLevel = 0
			seaFloorLevel = 0
			prefixTexN = "Tx"
			texOffsetX = 0
			texOffsetY = 0
		fa = 1
		
		try
		(
			fa= openFile terrainConFile	
			skipToString fa "late.worldSize "
			terrainworldSize = (readValue fa)
			seek fa 0
			skipToString fa "texBaseName "
			skipToString fa "\\Textures\\"
			prefixTexN = (readChars fa 2)
			seek fa 0
			skipToString fa "texOffsetX "
			texOffsetX = (readValue fa)
			seek fa 0
			skipToString fa "texOffsetY "
			texOffsetY = (readValue fa)
			seek fa 0
			skipToString fa "late.yScale "
			terrainScale = (readValue fa)
			if usewater do
			(	seek fa 0
				skipToString fa "late.waterLevel "
				waterLevel = (readValue fa)
				seek fa 0
				skipToString fa "late.seaFloorLevel "
				seaFloorLevel  = (readValue fa)
			)
			close fa
		)
		catch 
			print ("**ERROR reading: "+(terrainConFile as string)) 			


		try close fa
		catch 
		(
			messageBox ("No terrain.con file found, using defaults\n" + "Terrain Scale: " + (gl_defaultTerrainScale as string) + "\nWorld Size: " + (gl_defaultWorldSize as string)) title: "Warning!"
			print "**WARNING** no terrain.con file found, using defaults"
		)
	
		print ("terrainScale: "+(terrainScale as string))
		print ("terrainworldSize: "+(terrainworldSize as string))
		print ("prefixTexN: "+(prefixTexN as string))
		
--//Heightmap
		f=fopen hmFileName "rb"
	print ("HeighmapFile: "+(hmFileName as string))
		fseek f 0 #seek_end
		theFileSize = (ftell f)
	print ("theFileSize: "+(theFileSize as string))
		fseek f 0 #seek_set
		hmRes = (sqrt(theFileSize/2) as integer)
	print ("Heightmap res: "+(hmRes as string))
		fclose f
	
			--------------
			nSegs = hmRes/64
	print ("nSegs: "+(nSegs as string))
			if (texOffsetX < 0) do texOffsetX= 0
			if (texOffsetY < 0) do texOffsetY= 0
			
			if heapsize < 15000000 do
				heapsize+= 15000000  - heapsize
		
			for y=1 to nSegs do
			(
				for x=1 to nSegs do
				(
					hmValu = readbfHMseg hmFileName x y (x == nSegs) (y == nSegs)
					--print ("hmValu[1]: "+(hmValu[1] as string))
					-------------
					if hmValu.count == 4225 then -- buffer is filled
					(
						print ((y as string)+"x"+(x as string))
						terrainObject = generateBfheightmapSeg (terrainworldSize/nSegs) terrainScale 64 hmValu
						hmValu = undefined
						if ( gl_doOptimise ) do 
						(--	print ("Adding Optimize...")
							addModifier terrainObject Optimize()
						)
						clearUndoBuffer()
						if ( IdoTextures ) do
						(
							if (x > texOffsetX) and (y > texOffsetY) do
							(
								tmpFileName = (((getFilenamePath hmFileName) as string)+"Textures\\"+(parseTxName prefixTexN (abs(x-texOffsetX)) (abs(y-texOffsetY)) ".dds"))
								if (thisfileDoesExist tmpFileName) do
								(
									tmpMaterial = standard name:("Mat_"+(parseTxName prefixTexN  x y ""))
									tmpMaterial.maps[2] = (Bitmaptexture fileName:tmpFileName)
									showTextureMap tmpMaterial tmpMaterial.maps[2] true
									terrainObject.material = tmpMaterial
								)
							)
						)
						terrainObject.name = (parseTxName prefixTexN x y "")
						gc()
						terrainObject.pos = [ (x-1) * ( terrainworldSize/nSegs), (y-1) * ( terrainworldSize/nSegs), 0]
						uvw = Uvwmap()
						addModifier terrainObject  (uvw)
						uvw.vflip = true
						uvw.realWorldMapSize = False
						--uvw.length = 256.256
						--uvw.width = 256.256
						--uvw.height = 18.3676
						--uvw.utile = 1
						--uvw.vtile = 1
						--uvw.wtile = 1
						--collapseStack terrainObject
						
		
					)
					else print ("**Error hmValu.count = "+(hmValu.count as string))
				)
			)
		
		if usewater do
			Plane lengthsegs:1 widthsegs:1 length:terrainworldSize \
					width:terrainworldSize name:"water" pos:[terrainworldSize/2.0,terrainworldSize/2.0,waterLevel] wirecolor: gl_waterColour
			
			
	taskEndTime = timestamp()
	print ("Time taken: "+((taskEndTime - taskStartTime) as string) )	
	)
)
