-- Index
global rBF_rexman
global gl_terrainColour = (color 0 120 0)
global gl_waterColour = (color 0 0 120)
global gl_defaultExportHMScale = 1.0
global gl_defaultTerrainScale = 1.0
global gl_defaultWorldSize = 1024
global gl_defaultWorldSizeSelection = 1024
global gl_suncheck = false
global gl_waterCheck = false
gl_heightMapPath = (getBfSetting "HMPath")
global gl_currentHeightmapFile
gl_currentHeightmapFile = undefined
gl_doOptimise = (getBfSetting "doOptimise")
gl_doTextures = (getBfSetting "doTextures")
gl_defaultTerrainScale = getBfSetting ("defTScale")
gl_defaultWorldSizeSelection = getBfSetting ("defWSizeSel")
gl_defaultWorldSize = getBfSetting ("defWSize")
gl_sunCheck = getBFSetting ("suncheck")
gl_waterCheck = getBFSetting ("watercheck")

	filein (bfmsloc + "rBF_rexmisc.ms")
	filein (bfmsloc + "rBF_rexobjects.ms")

rollout rBF_rexman "Level Editing Rollout" width:552 height:384
(
-- MENU
	include "rBFi_topHeader.ms"

	GroupBox grp1 "Heightmap Tools" pos:[20,40] width:200 height:250
		checkbox sunCheck "Include Sun" pos:[25,60] width:88 height:15 tooltip: "Includes sun light object"
		checkbox terrainWaterLevelbox "Include water" pos:[25,80] width:88 height:15 tooltip:"Includes water plane"
		colorPicker waterColour "Water:" pos:[25,100] width:76 height:20 tooltip:"Color of the water plane"
		colorPicker terrainColour "Land:  " pos:[120,100] width:77 height:20 toolTip:"Color of the terrain"
		checkbox terrainOptimiseBox "Optimise" pos:[120,60] width:64 height:15 checked:false tooltip:"Simplifies terrain mesh"
		checkbox terrainTexturesBox "Textures" pos:[120,80] width:64 height:15 checked:true tooltip:"Includes terrain textures"
		spinner defaultScale "" pos:[100,130] width:60 height:16 range:[0,10,1] type:#float tooltip:"Scales all imported terrain. Leave at 1,0."
		dropdownList defaultWorldSize "" pos:[100,150] width:60 height:21 items:#("512", "1024", "2048", "4096")
		button importBfTerrainButton "Import terrain..." pos:[25,180] width:86 height:21 toolTip:"Make sure you import this from its level folder. Terrain.con is referenced."
		button loadSunBut "Load Sun only" pos:[25,260] width:134 height:21 toolTip:"Load \"SkyandSun.con\" Sun into scene as Directional Light"

		label lbl4 "Default Scale:" pos:[25,130] width:70 height:15
		label lbl5 "Default Size:" pos:[25,150] width:65 height:15
	
	GroupBox grp2 "Object Tools" pos:[225,40] width:140 height:85
	
		button ImportBfPlacementButton "Import placements..." pos:[235,60] width:128 height:18
		button freezeSelbtn "FreezeTerrain" pos:[235,80] height:18
		button unfreezAllbtn "Unfreeze Terrain" pos:[235,100] height:18
	
		on ImportBfPlacementButton pressed do
	(	fname = getOpenFileName caption:"Import .con" types:" .con|*.con|All|*.*|"
		importBfPlacement fname
		print "--Finished Import--"
	)
	
	GroupBox grp3 "Lightmap" pos:[225,135] width:220 height:155
		button listBfobjButton "List objects.." pos:[235,150] width:90 height:20 tooltip:"Lists all object names in the MaxScript Listener"
		button shadow_1button "SetupLightmaps selected" pos:[235,170] width:150 height:20 tooltip:"adds an element suffix to every selected object, required lightmaps before render-to-texture."
-- MISC FUNCTION CALLER		
		on listBfobjButton pressed do
			listObjectsNamesScene 0 0
		on shadow_1button pressed do
		SetupLightmapBF selection

-- LOAD GLOBALS AND FILES
	on rBF_rexman open do
	(
		if (gl_doOptimise == "true") then (terrainOptimiseBox.state = true ) else (terrainOptimiseBox.state = false )
		gl_doOptimise = terrainOptimiseBox.state

		if (gl_doTextures == "true") then (terrainTexturesBox.state = true ) else (terrainTexturesBox.state = false )
		gl_doTextures = terrainTexturesBox.state

		if (gl_suncheck == "true") then (sunCheck.state = true ) else (sunCheck.state = false )
		gl_suncheck = sunCheck.state
		
		if (gl_watercheck == "true") then (terrainWaterLevelbox.state = true ) else (terrainWaterLevelbox.state = false )
		gl_suncheck = terrainWaterLevelbox.state
		
		try
		(	defaultScale.value = gl_defaultTerrainScale
			defaultWorldSize.selection = gl_defaultWorldSizeSelection
		)
		catch ()

		terrainColour.color.r = (getBfSetting "trn_R"  as float)
		terrainColour.color.g = (getBfSetting "trn_G"  as float)
		terrainColour.color.b = (getBfSetting "trn_B"  as float)

		waterColour.color.r = (getBfSetting "wtr_R"  as float)
		waterColour.color.g = (getBfSetting "wtr_G"  as float)
		waterColour.color.b = (getBfSetting "wtr_B"  as float)


	gl_terrainColour = terrainColour.color
	gl_waterColour = waterColour.color
	)
	
-- ALL KINDS OF SETTINGS
	on waterColour changed val do
	(
		gl_waterColour = waterColour.color
		setBfSettingB "wtr_R" (gl_waterColour.r as string)
		setBfSettingB "wtr_G" (gl_waterColour.g as string)
		setBfSettingB "wtr_B" (gl_waterColour.b as string)
	)
	on terrainColour changed val do
	(
		gl_terrainColour = terrainColour.color
		setBfSettingB "trn_R" (gl_terrainColour.r as string)
		setBfSettingB "trn_G" (gl_terrainColour.g as string)
		setBfSettingB "trn_B" (gl_terrainColour.b as string)
	)
	on terrainOptimiseBox changed arg do
	(
		gl_doOptimise = arg
		setBfSettingB "doOptimise" (gl_doOptimise as string)
	)
	on terrainTexturesBox changed arg do
	(
		gl_doTextures = arg
		setBfSettingB "doTextures" (gl_doTextures as string)
	)
	on defaultScale changed arg do
	(
		gl_defaultTerrainScale = defaultScale.value
		setBfSettingB "defTScale" (gl_defaultTerrainScale as string)
	)
	on defaultWorldSize selected arg do
	(
		gl_defaultWorldSize = (defaultWorldSize.selected as integer)
		gl_defaultWorldSizeSelection = arg
		setBfSettingB "defWSizeSel" (gl_defaultWorldSizeSelection as string)
		setBfSettingB "defWSize" (gl_defaultWorldSize as string)
	)
	on sunCheck changed arg do
	(
		gl_sunCheck = arg
		setBfSettingB "sunCheck" (gl_sunCheck as string)
	)
	on terrainWaterLevelbox changed arg do
	(
		gl_waterCheck = arg
		setBfSettingB "waterCheck" (gl_waterCheck as string)
	)
	on importBfTerrainButton pressed do
	(
		fname = getOpenFileName caption: "HEIGHTMAP .raw" types:" .raw|*.raw|"
		if fname != undefined do
		(
	
			if ( gl_heightMapPath != undefined ) do
			(
				gl_heightMapPath = fname
			)

			--disableSceneRedraw()
			importBfterrain fname (terrainWaterLevelbox.checked) terrainTexturesBox.state

			if sunCheck.state then
			(
				skyAndSunPath = ((getFileNamePath fname) + "init\\SkyAndSun.con")
				ReadSkyBf skyAndSunPath 1.0
			)
			--EnableSceneRedraw()
		)
	)
	on loadSunBut pressed do
	(
		fname = getOpenFileName caption:"SkyAndSun.con to read" types:"SkyAndSun.con|SkyAndSun.con|All|*.*|"
		if (fname != undefined) do
		ReadSkyBf fname 1.0
	)
)